<?php   

Header("Cache-Control: no-cache");
Header("Pragma: no-cache");
Header("Expires: Sat, Jan 01 2000 01:01:01 GMT");

include("global.inc.php");


// Do this only once
$dnsbl_check = explode(":", SPAM_BLACKLISTS);
foreach ($dnsbl_check as $i => $dummy)
{
    $dnsbl_down[$i] = false;
    $dnsbl_nrcalls[$i] = 0;
    $dnsbl_resptime[$i] = 0;
}
$blacklist = array();

function has_attachment($struct)
{
    if(!isset($struct->parts) or !$struct->parts)
    {
        $att_name = get_att_name($struct);
        if ($att_name != "Unknown")
        {
            return true;
        }
    }
    else
    {
        for($j = 0; $j < count($struct->parts); $j++)
        {
            if (has_attachment($struct->parts[$j]))
                return true;
        }
    }
    return false;
}


function is_blacklisted($ip, $maxtime)
{
    global $dnsbl_check;
    global $dnsbl_down;
    global $blacklist;
    // Used for smart order
    global $dnsbl_nrcalls;
    global $dnsbl_resptime;

    /* $blacklist[$ip] is set to FALSE if $ip is found OK before. This
       will handle multiple emails from the same source much faster. */
    if (isset($blacklist[$ip]))
    {
        return $blacklist[$ip];
    }

    $listed = FALSE;
    if ($ip)
    {
        $quads = explode(".", $ip);
        $rip = $quads[3] . "." . $quads[2] . "." . $quads[1] . "." . $quads[0];
        /* Sort the list of spamlists according to responsetime. Then try 
           them in that order, fastest first. This should improve the
           amount of flagged spam and msgs considered.
         */
        asort($dnsbl_resptime);
        foreach ($dnsbl_resptime as $i => $dummy)
        {
            if ($dnsbl_down[$i])
                continue;
            $startus = microtime();
            $dnsbl_nrcalls[$i]++;
            if (checkdnsrr($rip . "." . $dnsbl_check[$i] . ".", "A")) 
            {
                $listed = $dnsbl_check[$i];
                break;
            }
            $stopus = microtime();
            list($u1, $s1) = explode(" ", $startus);
            list($u2, $s2) = explode(" ", $stopus);
            $uall = $s2 - $s1; 
            $resptime = $u2 - $u1 + $uall;
            $dnsbl_resptime[$i] = 
                ($dnsbl_resptime[$i] * ($dnsbl_nrcalls[$i] - 1) + $resptime) 
                / $dnsbl_nrcalls[$i];
                
            if ($resptime > MAX_SPAMFLAG_SECONDS_PER_CALL)
            {
                // Assume the last tried dnsbl was down
                $dnsbl_down[$i] = true;
                $dnsbl_resptime[$i] += $maxtime;
                break;
            }
        }
        /* cache results, as $listed or FALSE */
        $blacklist[$ip] = $listed;
        return $listed;
    }
}

function pagetitle()
{
    global $folder;
    return maketitle($folder);
}

$start = $_GET['start'];
$count = $_GET['count'];
$sort = $_GET['sort'];
$select = $_GET['select'];

function pagecontent()
{
?>
<script type="text/javascript">
<!--
function checkchecked()
{
    flag = false;
    for(i=0 ; i<document.delmov.elements.length; i++)
    {
        if(document.delmov.elements[i].type == "checkbox")
        {
            if(document.delmov.elements[i].checked)
            {
                flag = true;
            }
        }
    }
    if(!flag)
    {
        alert("<?php echo L_SELECT_ERROR ?>");
        document.delmov.tofolder.selectedIndex = 0;
    }
    return flag;
}

function doSubmit()
{
    if (checkchecked()) 
    {
        document.delmov.move.value = 1;
        document.delmov.submit();
    }
}

var newcheckstate = true;

function check_all()
{

    for(i=0 ; i<document.delmov.elements.length; i++)
    {
        if(document.delmov.elements[i].type == "checkbox")
        {
            document.delmov.elements[i].checked = newcheckstate;
        }
    }
    newcheckstate = !newcheckstate;
}
//-->
</script>
<?php
    content_start();
    header_start();
    
    global $folder;
    global $mailbox;
    global $start, $count;
    global $sort;

    header_left();
    global $user;
    echo pagetitle() . " - ";

    $issentmail = (($folder == SENT_MAIL) && (SENT_MAIL));
    $numcols = 6;
    if (!DISPLAY_TO_FIELD || $issentmail)
        $numcols--;

    if ($sort=="")
    {
        $sort = 100 + SORTARRIVAL;
    }
    $nummsg = imap_num_msg($mailbox);
    if ($nummsg > 0)
    {
        $s = $sort;
        $r = 0;
        if ($s > 99)
        {
            $s -= 100;
            $r = 1;
        }
        
        $msg_array = imap_sort($mailbox, $s, $r, SE_UID);
    }
    // code to display start to count
    $msg_start = $start ? $start : 1;
    $msg_start--;
    $tmp_count = $count ? $count : MSG_COUNT;
    $tmp_display = $tmp_count > $nummsg ? $nummsg : $tmp_count;
    $nummsg_display = $tmp_display > ($nummsg - $msg_start) ? ($nummsg - $msg_start) : $tmp_display;

    /* Check for spam. This is slow, so lots of optimisation here... */
    flush(); // So the user sees *something*
    $spam_to_move = array();
    $possible_spam = array();

    $numtoget = $nummsg_display; // This is the number of non-spam messages we need
    if (SPAM_BLACKLISTS or SPAM_REGEXP or SPAM_HEADER)
    {
        $starttime = time();
        // We loop till the end, to ensure we have enough non-spam messages if moving.
        // We break out early if necessary.
        for ($i=$msg_start ; $i < $nummsg; $i++) 
        {
            $msg = imap_headerinfo($mailbox, imap_msgno($mailbox, $msg_array[$i]));
            /* Don't bother if message is already read */
            if ($msg->Unseen == 'U' || $msg->Recent == 'N')
                $new = true;
            else
                $new = false;
            if ($new)
            {
                if (strlen(SPAM_REGEXP) > 0
                    and preg_match("/" . SPAM_REGEXP . "/", $msg->subject))
                {
                    $possible_spam[$msg_array[$i]] = SPAM_REGEXP;
                }
                else
                {
                    $rawheaders = imap_fetchbody($mailbox, $msg_array[$i], 0,
                                                    FT_UID | FT_PEEK);
                    if (strlen(SPAM_HEADER) > 0 and 
                        preg_match("/^" . preg_quote(SPAM_HEADER) . "\r?/m",
                            $rawheaders))
                    {
                        $possible_spam[$msg_array[$i]] = SPAM_HEADER;
                    }
                    else
                    {
                        $headers = explode("Received: ", $rawheaders);
                        for ($h = 0; $h < count($headers); $h++)
                        {
                            if (preg_match("/^from ([^ ]* )?\(([^ ]* )?\[([0-9\.]*)\]/", $headers[$h], $regs))
                            {
                                $fromip = $regs[3];
                                $ret = is_blacklisted($fromip, MAX_SPAMFLAG_SECONDS);
                                if ($ret)
                                {
                                    $possible_spam[$msg_array[$i]] = $ret;
                                    break;
                                }
                            }
                        }
                    }
                }
            }
            if (array_key_exists($msg_array[$i], $possible_spam) and JUNK_MAIL and $folder != JUNK_MAIL)
            {
                $spam_to_move[] = $msg_array[$i];
            }
            else
            {
                // we will display this msg
                $numtoget--;
                // If we have enough to display we can stop flagging
                if ($numtoget <= 0)
                    break;
            }
            // If it takes too long, we stop
            if (time() - $starttime > MAX_SPAMFLAG_SECONDS)
            {
                break;
            }
        }
        // If necessary, move spam to another folder.
        if (count($spam_to_move) > 0 and JUNK_MAIL and $folder != JUNK_MAIL)
        {
            $msglist = implode(",", $spam_to_move);
            $junk_folder = construct_folder_str(JUNK_MAIL);
            $moved = imap_mail_move($mailbox, $msglist, $junk_folder, CP_UID);
            if (!$moved)
            {
                // Make sure we don't get the error screen
                $foo = imap_errors();
                // Assume it didn't work because the folder does not exist
                imap_createmailbox($mailbox, IMAP_STR . "$junk_folder");
                // And try again
                $moved = imap_mail_move($mailbox, $msglist, $junk_folder, CP_UID);
            }
            imap_expunge($mailbox);
        }
    }

    // Now, retrieve the list again (it has changed because of move spam)
    if (count($spam_to_move) > 0 and JUNK_MAIL and $folder != JUNK_MAIL)
    {
        $nummsg = imap_num_msg($mailbox);
        if ($nummsg > 0)
        {
            $msg_array = imap_sort($mailbox, $s, $r, SE_UID);
        }
        // Also repeat number to display, as we might have less to do
        $tmp_count = $count ? $count : MSG_COUNT;
        $tmp_display = $tmp_count > $nummsg ? $nummsg : $tmp_count;
        $nummsg_display = $tmp_display > ($nummsg - $msg_start) ? ($nummsg - $msg_start) : $tmp_display;
    }
    echo "$nummsg"; 
    $out = " " . ($nummsg == 1 ? L_MESSAGE : L_MESSAGES);
    echo $out;
    header_left_right_end();

?>

<?php

    if (USE_FOLDERS) {
        header_right();
?>
        <form name="switchbox" action="index.php" method="GET">
        <select name=folder onChange="submit()">
        <option value=""><?php echo L_FOLDER_SWITCH ?>:
        <?php list_folders($mailbox); ?>
        </select>
        <noscript>
        <input type="submit" value="<?php echo L_SUBMIT_BTN ?>">
        </noscript>
        </form>
<?php
        header_left_right_end();
        header_right();
        echo "&nbsp;&nbsp;&nbsp;";
        header_left_right_end();
        header_right();
?>
        <form action="folder.php" method="get">
        <input type="hidden" name="folder" value="<?php echo $folder ?>">
        <input type="submit" value="<?php echo L_FOLDER_BTN ?>">
        </form>
<?php 
        header_left_right_end();
    }
    header_right();
?>
        <form action="logout.php" method="get">
        <input type="submit" value="<?php echo L_LOGON_BTN ?>">
        </form>
<?php
    header_left_right_end();
    header_end();
    body_start();
    title_start();
    title_left('nowrap="nowrap"');
    if (WRITE_MESSAGES or DELETE_MESSAGES or MULTIMESSAGE)
    {
?>

        <form name="delmov" action="action.php" method="POST" onsubmit="return checkchecked()">
        <input type="hidden" name="folder" value="<?php echo "$folder" ?>">
        <?php if (USE_COOKIES) { ?>
            <input type="hidden" name="token" value="<?php echo $_SESSION['token'];?>"/>
        <?php } ?>
<?php
    }
?>
    <a href="<?php echo htmlspecialchars($_SERVER["REQUEST_URI"]) ?>"><img src="images/refresh2.gif" alt="@" border="0" height="16" width="16"></a>
<?php 
    title_left_end();
    title_left('nowrap="nowrap"');
    global $sort;
    echo "<a class=\"intf\" href=\"";
    if ($sort == SORTSUBJECT)
        $s = 100 + SORTSUBJECT;
    else
        $s = SORTSUBJECT;
    echo self_with_param("sort", $s);
    echo "\">";
    echo L_SUBJECT_HDR;
    echo "&nbsp;";
    if ($sort == SORTSUBJECT)
        echo "<img src=\"images/ascending.gif\" alt=\"^\" width=\"8\" height=\"8\" border=\"0\">";
    if ($sort == 100 + SORTSUBJECT)
        echo "<img src=\"images/descending.gif\" alt=\"v\" width=\"8\" height=\"8\" border=\"0\">";
    echo "</a>";
    title_left_end();
    if (!$issentmail)
    {
        title_left('nowrap="nowrap"');
        echo "<a class=\"intf\" href=\"";
        if ($sort == SORTFROM)
            $s = 100 + SORTFROM;
        else
            $s = SORTFROM;
        echo self_with_param("sort", $s);
        echo "\">";
        echo L_FROM_HDR;
        echo "&nbsp;";
        if ($sort == SORTFROM)
            echo "<img src=\"images/ascending.gif\" alt=\"^\" width=\"8\" height=\"8\" border=\"0\">";
        if ($sort == 100 + SORTFROM)
            echo "<img src=\"images/descending.gif\" alt=\"v\" width=\"8\" height=\"8\" border=\"0\">";
        echo "</a>";
        title_left_end();
    }
    if (DISPLAY_TO_FIELD || $issentmail)
    {
        title_left('nowrap="nowrap"');
        echo "<a class=\"intf\" href=\"";
        if ($sort == SORTTO)
            $s = 100 + SORTTO;
        else
            $s = SORTTO;
        echo self_with_param("sort", $s);
        echo "\">";
        echo L_TO_HDR;
        echo "&nbsp;";
        if ($sort == SORTTO)
            echo "<img src=\"images/ascending.gif\" alt=\"^\" width=\"8\" height=\"8\" border=\"0\">";
        if ($sort == 100 + SORTTO)
            echo "<img src=\"images/descending.gif\" alt=\"v\" width=\"8\" height=\"8\" border=\"0\">";
        echo "</a>";
        title_left_end();
    }
    title_left('nowrap="nowrap"');
    echo "<a class=\"intf\" href=\"";
    if ($sort == SORTARRIVAL)
        $s = 100 + SORTARRIVAL;
    else
        $s = SORTARRIVAL;
    echo self_with_param("sort", $s);
    echo "\">";
    echo $issentmail ? L_SENT_HDR : L_RECEIVED_HDR;
    echo "&nbsp;";
    if ($sort == SORTARRIVAL)
        echo "<img src=\"images/ascending.gif\" alt=\"^\" width=\"8\" height=\"8\" border=\"0\">";
    if ($sort == 100 + SORTARRIVAL)
        echo "<img src=\"images/descending.gif\" alt=\"v\" width=\"8\" height=\"8\" border=\"0\">";
    echo "</a>";
    title_left_end();
    title_left('nowrap="nowrap"');
    echo "<a class=\"intf\" href=\"";
    if ($sort == SORTSIZE)
        $s = 100 + SORTSIZE;
    else
        $s = SORTSIZE;
    echo self_with_param("sort", $s);
    echo "\">";
    echo L_SIZE_HDR;
    echo "&nbsp;";
    if ($sort == SORTSIZE)
        echo "<img src=\"images/ascending.gif\" alt=\"^\" width=\"8\" height=\"8\" border=\"0\">";
    if ($sort == 100 + SORTSIZE)
        echo "<img src=\"images/descending.gif\" alt=\"v\" width=\"8\" height=\"8\" border=\"0\">";
    echo "</a>";
    title_left_end();
    title_end('nowrap="nowrap"');

    $flipflop = 0;
    $nummsgdisplayed = 0;
    global $select;

    for( $i=$msg_start ; $i < $msg_start + $nummsg_display ; $i++ )
    {

        $struct = imap_fetchstructure($mailbox, $msg_array[$i], FT_UID);


        $attach = has_attachment($struct) ? "&nbsp;@" : "";
        $msg = imap_headerinfo($mailbox, imap_msgno($mailbox, $msg_array[$i]));
        $subject = !$msg->Subject ? L_NO_SUBJECT : $msg->Subject;
        $subject = decode_header_string($subject);
        $subject = htmlspecialchars($subject);

        $ksize = round($msg->Size/1024);
        $size = $msg->Size > 1024 ? "$ksize KB" : $msg->Size;

        if($flipflop == 0)
        {
            $bg = "rowon";
            $flipflop = 1;
        }
        else
        {
            $bg = "rowoff";
            $flipflop = 0;
        }
        if ($msg->Unseen == 'U' || $msg->Recent == 'N')
            $new = true;
        else
            $new = false;
        if ($msg-> Answered == 'A' && !$new)
            $replied = true;
        else
            $replied = false;
        if ($new)
            $bg .= "new";
        if ($replied)
           $bg .= "replied";
        // Let's start displaying.
        $nummsgdisplayed++;
        body_row('class="' . $bg . '"');
        body_check();
        if (WRITE_MESSAGES or DELETE_MESSAGES or MULTIMESSAGE)
        {
            echo "<input type=\"checkbox\" name=\"msglist[]\" value=\"$msg_array[$i]\"";
            if ($select=="all")
                echo " checked=\"checked\"";
            if (/*$select=="spam" &&*/ array_key_exists($msg_array[$i], $possible_spam))
                echo " checked=\"checked\"";
            echo ">";
        }
        body_check_end();
        body_left();
        if (array_key_exists($msg_array[$i], $possible_spam))
            print "<font color=\"red\">***" . L_JUNK_MAIL . "*** </font>";
        echo "<a class=\"intf\" href=\"message.php?folder=" . urlencode($folder) . "&amp;msglist[]=$msg_array[$i]\">";
        echo $subject;
        echo "</a>$attach\n";
        if (array_key_exists($msg_array[$i], $possible_spam))
            print "<br><font color=\"red\"><small>(" 
                    . $possible_spam[$msg_array[$i]] . ")</small></font>";
        body_left_end();
        if(!$issentmail)
        {
            body_left();
            if($msg->from)
                echo make_clickable_list($msg->from, $folder, MAX_DISPLAY_ADDRESSES);
            else
                echo L_NO_FROM;
            body_left_end();
        }
        if ($issentmail || DISPLAY_TO_FIELD)
        {
            body_left();
            if ($msg->to)
                echo make_clickable_list($msg->to, $folder, MAX_DISPLAY_ADDRESSES);
            else
                echo L_NO_TO;
            body_left_end();
        }
        body_left('nowrap="nowrap"');
        echo date(L_DATE_FORMAT, $msg->udate);
        body_left_end();
        body_left('nowrap="nowrap" align="right"');
        echo $size;
        body_left_end();
        body_row_end();
    }
    if ($nummsgdisplayed == 0)
    {
        body_row('class="rowon"');
        body_left('colspan="' . $numcols . '"');
        echo L_FOLDER_EMPTY;
        body_left_end();
        body_row_end();
    }


    title_start();
    title_left();
    if (WRITE_MESSAGES or DELETE_MESSAGES or MULTIMESSAGE)
    {
?>
<script type="text/javascript">
    document.write('<a href="javascript:check_all()"><img src="images/check2.gif" alt="V" border="0" height="16" width="16"></a>');
</script>
<noscript>
<?php

        if ($select!="all")
            $url = self_with_param("select", "all");
        else
            $url = self_with_param("select", "");
        echo "<a href=\"$url\"><img src=\"images/check2.gif\" alt=\"V\" border=\"0\" height=\"16\" width=\"16\"></a>";
?>
</noscript>
<?php
        /*
        if (SPAM_BLACKLISTS)
        {
            if ($select!="spam")
            {
                $url = self_with_param("select", "spam");
                echo "<br><a class=\"intf\" href=\"$url\">spam</a>";
            }
        }
        */
    }
    title_left_end();
    $colsleft = $numcols-1;
    title_left('colspan="' . $colsleft . '"');

    $location = $msg_start + 1;

    for($k=1; $k <= $nummsg; $k += $tmp_count)
    {
        $end_tmp = $k + $tmp_count - 1;
        $end = $end_tmp >= $nummsg ? $nummsg : $end_tmp;

        $newlink = "<a class=\"msg\" href=\"index.php?folder=$folder&amp;sort=$sort&amp;start=$k&amp;count=$tmp_count\">";
        $link = (($k <= $location) and ($location <= $end)) ?  "" : $newlink;
        echo $link . "[$k-" . $end;
        $link = (($k <= $location) and ($location <= $end)) ?  "" : "</a>";
        echo "]" . $link;

        echo "&nbsp;&nbsp; ";
    }
    $numspam = count($spam_to_move);
    if (SPAM_BLACKLISTS and JUNK_MAIL and $folder != JUNK_MAIL)
    {
        print "<small>" . L_JUNK_MAIL . ": $numspam "
                . ($numspam == 1 ? L_MESSAGE : L_MESSAGES)
                . " -&gt; <a class=\"intf\" href=\"index.php?folder=" 
                . JUNK_MAIL . "\">" . JUNK_MAIL . "</a></small>";
    }

    title_left_end();
    title_end();
    body_end();

    header_start();
    header_left();
    if (USE_FOLDERS) {
?>        
        <select name="tofolder" onChange="doSubmit()">
        <option><?php echo L_FOLDER_MOVE ?>
        <?php list_folders($mailbox); ?>
        </select>
        <script type="text/javascript">
        <!--
            // A var named 'move' must always exist.
            document.write('<input type="hidden" name="move" value="">');
        //-->
        </script>
        <noscript>
            <input type="submit" name="move" value="<?php echo L_SUBMIT_BTN ?>">
        </noscript>
<?php
    }
    echo "&nbsp;";
    header_left_right_end();
    if (MULTIMESSAGE)
    {
        header_right();
?>
        <input type="submit" name="readall" value="<?php echo L_READ_BTN ?>">
<?php
        header_left_right_end();
    }
    if (DELETE_MESSAGES)
    {
        header_right();
?>
        <input type="submit" name="delall" value="<?php echo L_DELETE_BTN ?>">
        </form>
<?php
        header_left_right_end();
    }
    if (WRITE_MESSAGES)
    {
        header_right();
?>
        <form action="compose.php" method="get">
        <input type="hidden" name="folder" value="<?php echo $folder ?>">
        <input type="submit" value="<?php echo L_COMPOSE_BTN ?>">
        </form>
<?php
        header_left_right_end();
    }
    header_end();
    content_end();
    imap_close($mailbox); 
}

/* MAIN */
include(HTML_TEMPLATE);

?>
